#ifndef _AC_STDIO_H
#define _AC_STDIO_H

#include "ac.h"
#include <curl/curl.h>
#include <stddef.h>
#define AC_MAXURLLEN 256

#define AC_FILE_FLAG_LOCAL (1 << 0)

#define AC_FILE_MAGIC 0x1337BABE

#define AC_STATE_UNBOUND	1
#define AC_STATE_BOUND		2

struct sFILE {
	long offset;  /* The internal offset */
	CURL *curl;   /* The pointer to the curl structure */
	void *curbuf; /* The pointer to the current io buffer */
	unsigned flags; /* The flags */
	FILE *localfile;
	volatile long curoffset; /* The current offset in bytes in the curbuf */
	volatile long toread;  /* The bytes left to read in this call to fread */
	int state;
};

typedef struct sFILE AC_FILE;

AC_FILE *ac_fopen(const char *url, const char *mode);
size_t ac_fread(void *ptr, size_t size, size_t nelem, AC_FILE *stream);
size_t ac_fread_complete(void **ptr, AC_FILE *stream);
int ac_fclose(AC_FILE *stream);
char *ac_fgets(char *s, int n, AC_FILE *stream);
int ac_fseek(AC_FILE *stream, long offset, int mode);
long ac_ftell(AC_FILE *stream);

#ifdef _USE_AC
#define fopen ac_fopen
#define fread ac_fread
#define fclose ac_fclose
#define fgets ac_fgets
#define fseek ac_fseek
#define ftell ac_ftell
#define FILE AC_FILE
#endif

#endif
